#pragma once
#include <QDialog>
#include <QListView>
#include <QStandardItemModel>
#include <QComboBox>
#include <QPushButton>
#include <QTimer>
#include <DeduceFramework.h>

class TempletAssemble : public QDialog
{
	Q_OBJECT
private:
	std::shared_ptr<DeduceFramework> _bind_framework;
	QTimer *const _bind_timer;

	QListView *const _templet_present;
	QStandardItemModel *const _templet_model;
	QPushButton *const _t_add, *const _t_remove;

	QWidget *const _right_widget;
	QLineEdit *const _templet_name;
	QComboBox *const _component_types;
	QPushButton *const _comp_add, *const _comp_remove;
	QListView *const _component_present;
	QStandardItemModel *const _component_model;
	QPushButton *const _apply;

	void deduce_start();
	void reply_accept(const QList<std::shared_ptr<WsMessage>>& set);
	void complete_accept(std::shared_ptr<RespondDefault> ins);

	void show_templet_content(const QModelIndex& target);

	void append_templet();

public:
	TempletAssemble(std::shared_ptr<DeduceFramework> fmk, QWidget *p = nullptr);
	virtual ~TempletAssemble() = default;

signals:
	void backend_deduce_request(std::shared_ptr<const DeduceRequest> ins);
};

